//
// Mage's Maze version 0.1. Try to find the blue orb, or die!
//
// By Vincent van Beveren
//
var font = GetSystemFont();
font.drawText(100, 110, "Loading intro...");
FlipScreen();
RequireScript('maze.js');



var completed = LoadImage('completed.png');
var startOfGame = 0;

var bgMusic;
var time;

function game() {
	bgMusic = LoadSound("magick.mid");
	bgMusic.play(false);
	LoadImage('magesmaze.png' ).blit(20, 30);
	// TODO, write better story.
	font.drawText(35, 150, "Blahdy blady blah, you are a wizard");	
	font.drawText(35, 160, "trapped in a maze. Try to find the");	
	font.drawText(35, 170, "  blue orb, so you can get out.");		
	font.drawText(35, 180, " (its in the lower right corner)");		
	font.drawText(35, 220, "     Press any key to start");		
	FlipScreen();
	
	
	while (!IsAnyKeyPressed()) {
	}
	bgMusic.stop();
	
	font.drawText(100, 110, "Loading game...");
	FlipScreen();
	bgMusic = LoadSound("deserticdungeon.mid");
	CreatePerson("elmar", "elmar.rss", false);
	AttachCamera("elmar");	
	AttachInput("elmar");
	SetRenderScript('render()');
	SetDefaultMapScript(SCRIPT_ON_ENTER_MAP, "init();");
	MapEngine("65x65.rmp", 60);
	
	
}

function render() {
	if (startOfGame == 0) {
		completed.blit(35, 80);
		font.drawText(120, 140, "In " + time + " minutes!");
		return;
	}

	var sInGame = Math.floor((GetTime() - startOfGame) / 1000);

	var minutes = Math.floor(sInGame / 60);
	var seconds = sInGame % 60;
	if (seconds < 10) {
		seconds = '0' + seconds;
	}
	time = minutes + ":" + seconds;
	font.drawText(5, 220, time);	
	if (sInGame > 5 && sInGame < 10) {
		font.drawText(5, 200, "Crap, where am I??...");		
	} else if (sInGame > 10 && sInGame < 15) {
		font.drawText(5, 200, "I should have listend to my mother...");		
	} else if (sInGame > 190 && sInGame < 200) {
		font.drawText(5, 200, "Getting annoyed yet? I would...");		
	} else if (sInGame > 360 && sInGame < 380) {
		font.drawText(5, 200, "I shouldn't be that hard...");		
	} else if (sInGame > 600) {
		font.drawText(5, 200, "You can do it!!!");		
	}
	
}

function finished() {
	DetachInput();
	startOfGame = 0;
	bgMusic.stop();
	s = LoadSound("fade2.wav");
	s.play(false);
	tf = false;
	for (i = 120; i < 220; i += 5) {
		SetDelayScript(i, "SetPersonVisible('elmar', " + tf + ")");
		tf = !tf;
	}
	SetDelayScript(225, "SetPersonVisible('elmar', false)");
	
}

function init() {
	maze = new Maze(65, 65);
	for (y = 0; y < maze.height; y++) {
		for (x = 0; x < maze.width; x++) {
			switch (maze.get(x, y)) {
				case 0:
					if (x == maze.width - 2 && y == maze.height - 2) {
						SetTile(x, y, 0, 4);
					} else {
						if (Math.random() < 0.1) {
							n = Math.random();
							if (n < 0.7) {
								SetTile(x, y, 0, 9);
							} else if (n < 0.9) {
								SetTile(x, y, 0, 10);
							} else {
								SetTile(x, y, 0, 8);
							}
						} else {
							SetTile(x, y, 0, 0);
						}
					}
					break;
				case 1:
					if (y > 0 && maze.get(x, y - 1) == 0) {
						SetTile(x, y, 0, 1);
					} else {
						SetTile(x, y, 0, 2 + Math.floor(Math.random() * 2));
					}
					break;
				
			}
			
		}
	}
	startOfGame = GetTime();
	bgMusic.play(true);
}